﻿var cts = new CancellationTokenSource();
var token = cts.Token;

Worker worker = new Worker();
var tasks = new Task<int>[]
{
    worker.DoSomeWork(2, token), //this will complete first
    worker.DoSomeOtherWork(4, token) //this will be cancelled after the first one completes
};

var completedTask = await Task.WhenAny(tasks); //first task completes
Console.WriteLine($"Completed first task {completedTask.MethodName()}, result = {await completedTask}");

cts.Cancel(); //cancel the other task

foreach (var task in tasks)
{
    try 
    {
        Console.WriteLine($"{task.MethodName()}. Id {task.Id}, result {await task}, status {task.Status}");
    }
    catch(OperationCanceledException ex)
    {
        Console.WriteLine($"{task.MethodName()}. Id {task.Id}, status {task.Status}, {ex.Message}");
    }
}
